package 
{
	import adobe.utils.ProductManager;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import net.flashpunk.Engine;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.World;
	
	/**
	 * ...
	 * @author 
	 */
	public class Gamer extends Entity 
	{
		[Embed(source = "shadow.png")] public static var SH:Class;
		public static var shadow:Image = new Image(SH);
		public var spr:Spritemap;
		public var speed:Number = 1.2;
		public var acc:Number = .1;
		public var decc:Number = .96;
		
		public var h:Number = 0;
		
		public var vx:Number = 0;
		public var vy:Number = 0;
		public var vh:Number = 0;
		
		public var hitted:uint = 0;
		public var shadecol:uint = 0;
		public var noshade:Boolean = false;
		
		public static var lasthit:Gamer = null;
		public var juggle:uint = 0;
		
		public var turbo:uint = 0;
		
		public var $:int = 10;
		
		public var dead:Boolean = false;
		
		public function Gamer():void 
		{
			
			
		}
		
		public function hit(by:Gamer = null):void
		{
			if (!by)
			{
				var a:Number = Math.PI * 2 * Math.random();
				var d:Number = 5 + Math.random() * 5;
				vx = Math.cos(a) * d;
				vy = Math.sin(a) * d;
			} else { 
				vx = x - by.x;
				vy = y - by.y;
				var d:Number = Math.sqrt(vx * vx + vy * vy);
				var f:Number = 5 + Math.random() * 5;
				vx /= d;
				vy /= d;
				vx *= f;
				vy *= f;
			}
			
			for (var c:uint = 0; c < 10; c++ )
			{
				FP.world.add(new Blood(x, y));
			}
			
			vh = 5;
			hitted = 50;
			spr.play("hit");
			trace("hit");
			if (lasthit == this)
			{
				juggle++;
			} else {
				if (lasthit) lasthit.juggle = 0;
				juggle = 1;
				lasthit = this;
			}
			if (juggle > 5) 
			{
				juggle = 0;
				turbo = 10;
				vx *= 2.5;
				vy *= 2.5;
			}
			if (this is Player) $=Q.score[(this as Player).id];
			for (var c:uint = 0; c < 5; c++)
			{
				if ($) 
				{
					$--;
					FP.world.add(new Item(0, x, y));
				}
			}
			if (this is Player) Q.score[(this as Player).id]=$;
			
			
			
		}
		
		public function collide3(x:Number, y:Number):Gamer
		{
			var g:Gamer = collide(type, x, y) as Gamer;
			if (!g) return null;
			if (Math.abs(g.h - h) < 16) return g;
			return null;
		}
		
		
		override public function update():void 
		{
			var g:Entity = collide("wall", x + vx, y + vy) as Entity;
			if (g)
			{
				if (this is Player) (this as Player).walking = false;
				//if (!p.walking && !Input.mousePressed) walking = false;
				vx = -vx;
				vy = -vy;
				
			}
			
			if (!turbo)
			{
				vx = FP.clamp(vx, -speed, speed);
				vy = FP.clamp(vy, -speed, speed);
			} else {
				turbo--;
				var s:Smoke = new Smoke(x, y);
				s.h = h;
				FP.world.add(s);
			}
			x += vx;
			y += vy;
			h += vh;
			vx *= decc;
			vy *= decc;
			vh -= .3;
			if (h < 0) 
			{
				h = 0;
				vh *= -.5;
				if (Math.abs(vh) < 2) vh = 0;
				else if (!(this is Blood))
				{
					for (var c:uint = 0; c < 10; c++ )
					{
						FP.world.add(new Blood(x, y));
					}
					for (var c:uint = 0; c < 2; c++ ) 
					{
						FP.world.add(new Smoke(x, y, -2 + 4 * c, 0));
					}
				}
			}
			
			if (hitted) hitted--;
			layer = FP.height - y;
			super.update();
		}
		
		override public function render():void
		{
			shadow.color = shadecol;
			if (!noshade) shadow.render(FP.buffer, new Point(x, y), FP.camera);
			spr.render(FP.buffer, new Point(x, y-h), FP.camera);
		}
		
	}
	
}