package 
{
	import adobe.utils.ProductManager;
	import flash.display.Sprite;
	import flash.events.Event;
	import net.flashpunk.Engine;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.World;
	
	/**
	 * ...
	 * @author 
	 */
	public class Player extends Gamer 
	{
		[Embed(source = "squad.png")] public var GFX:Class;
		
		
		public var id:uint = 0;
		
		public var target_x:Number = 0;
		public var target_y:Number = 0;
		public var target_h:Number = 0;
		public var target:Gamer = null;
		public var walking:Boolean = false;
		public var attacking:uint = 0;
		public var kicking:uint = 0;
		

		
		public function Player(id:uint):void 
		{
			Q.players[id] = this;
			spr= new Spritemap(GFX, 32, 32,ended);
			x = 40+(id/2)*40;
			y =60+(id%2)*40;
			this.id = id;
			
			spr.add("taunt", [0], 10, true,id*12);
			spr.add("idle", [1, 2], 8+FP.rand(4), true, id * 12);
			spr.add("kick", [3, 4], 4+FP.rand(3), false, id * 12);
			spr.add("punch", [3, 5], 4+FP.rand(3), false, id * 12);
			spr.add("hit", [6], 10, true, id * 12);
			spr.add("jump", [7], 10, true, id * 12);
			spr.add("walk", [8,9,10,9], 10, true, id * 12);
			spr.add("dead", [11], 10, true, id * 12);
			
			spr.play("idle");
			
			graphic = spr;
			spr.originX = 16;
			spr.originY = 32;
			
			type = "gamer";
			setHitbox(16, 8, 8, 8);
			$ = 50;
			
		}
		
		public function ended():void
		{
			if (kicking) 
			{
				kicking = 0;
				spr.play("taunt");
			}
			
		}
		
		override public function update():void 
		{
			if (!hitted)
			{
			if (Input.mousePressed && !Q.action)
			{
				var g:Gamer = FP.world.collidePoint("gamer", Input.mouseX, Input.mouseY) as Gamer;
				if (g)
				{
					target = g;
					target_x = g.x;
					target_y = g.y;
					target_h = g.h;
				} else {
					target_x = Input.mouseX;
					target_y = Input.mouseY;
					target_h = 0
				}
				walking = true;
				//Q.action = true;
			}
			if (walking)
			{
				if (x > target_x) vx-=acc; else vx+=acc;
				if (y > target_y) vy -= acc; else vy += acc;
				/*
				if (target)
				{
					if (collideWith(target, x,y))
					{
						spr.play(FP.rand(2) ? "kick" : "punch");
						attacking = 1;
						vx = 0;
						vy = 0;
					}
				} else {*/
					if (collidePoint(x, y, target_x, target_y)) walking=false;
				//}
			}
			
			if (!Q.action)
			{
				if (x>Input.mouseX) spr.flipped = true; else spr.flipped = false;
			} else {
				if (vx < 0) spr.flipped = true; else spr.flipped = false;
			}
			if (collide3(x,y) && !kicking)
			{
				trace("collide! ",attacking,kicking,spr.frame);
				spr.play(FP.rand(2) ? "kick" : "punch");
				vx = 0;
				vy = 0;
				kicking = 1;
				attacking = 0;
			}
			
			if ((spr.frame == 4+id*12 || spr.frame == 5+id*12) && attacking==0)
			{
				trace("attack!");
				attacking=1;
				var g:Gamer = collide3(x, y) as Gamer;
				if (g)
				{
					g.hit(this);
					//Q.score[id] += $;
					
				}
			
				
			} 
			if ((spr.frame != 4 && spr.frame != 5)) attacking = 0;
			
			} else {
				walking = 0;
				attacking = 0;
				kicking = 0;
			}
			super.update();
			
			var i:Item = collide("item", x, y) as Item;
			if (i) if (!i.delay) 
			{
				i.take(this);
				FP.world.add(new Oneup(x, y));
			}
			
			
			
			
			/*
			if (attacking)
			{
				if (attacking == 1)
				{
					if ((spr.frame == 4 || spr.frame == 5))
					{
						attacking = 0;
						target.hit();
						target = null;
						walking = 0;
						/*
						vx = target.x - x;
						vy = target.y - y;
						vh = target.h - h;
						*//*
					}
				} 
				
			}
			*/
			
			if (!kicking)
			{
				if (hitted) 
				{
					if (vh<2) spr.play("dead"); else spr.play("hit");
				}
				else if (walking) spr.play("walk"); else 
				{
					if (!Q.action) spr.play("taunt"); else spr.play("idle");
				}
			}
			
			
		}
		
	}
	
}